/*-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/*/
/*-					       -*/
/*-     ___       ___       ___       ___      -*/
/*-    /\  \     /\__\     /\  \     /\  \     -*/
/*-   /::\  \   /:| _|_   _\:\  \   /::\  \    -*/
/*-  /::\:\__\ /::|/\__\ /\/::\__\ /:/\:\__\   -*/
/*-  \;:::/  / \/|::/  / \::/\/__/ \:\/:/  /   -*/
/*-   |:\/__/    |:/  /   \:\__\    \::/  /    -*/
/*-    \|__|     \/__/     \/__/     \/__/     -*/
/*-					       -*/
/*-  - RedKod NetWork Informations Displayer - -*/
/*-           http://www.redkod.com/           -*/
/*-					       -*/
/*- Coder : R-e-D			       -*/
/*- Mail  : r-e-d@redkod.com		       -*/
/*-					       -*/
/*-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/*/

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>

#include <wchar.h>
#include <iphlpapi.h>


int GetAndDisplayIpStatistics(void)
{
	PMIB_IPSTATS pStats;

	pStats = (PMIB_IPSTATS)malloc(sizeof(PMIB_IPSTATS));
	free(pStats);
	
	if(GetIpStatistics(pStats) == NO_ERROR)
	{
		fprintf(stdout, "=================\n");
		fprintf(stdout, "= IP Statistics =\n");
		fprintf(stdout, "=================\n\n");
		fprintf(stdout, "- IP Forwarding : %d\n", pStats->dwForwarding);
		fprintf(stdout, "- Default TTL : %d\n", pStats->dwDefaultTTL);
		fprintf(stdout, "- Number of datagrams received : %d\n", pStats->dwInReceives);
		fprintf(stdout, "- Number of datagrams with headers errors : %d\n", pStats->dwInHdrErrors);
		fprintf(stdout, "- Number of datagrams forwarded : %d\n", pStats->dwForwDatagrams);
		fprintf(stdout, "- Number of datagrams received that have an unknown protocol : %d\n", pStats->dwInUnknownProtos);
		fprintf(stdout, "- Number of received datagrams discarded : %d\n", pStats->dwInDiscards);
		fprintf(stdout, "- Number of received datagrams delivered : %d\n", pStats->dwInDelivers);
		fprintf(stdout, "- Number of outgoing datagrams that IP is requested to transmit : %d\n", pStats->dwOutRequests);
		fprintf(stdout, "- Number of outgoing datagrams discarded : %d\n", pStats->dwRoutingDiscards);
		fprintf(stdout, "- Number of transmitted datagrams discarded : %d\n", pStats->dwOutDiscards);
		fprintf(stdout, "- Number of datagrams for which this computer did not have a route to the destination IP address : %d\n", pStats->dwOutNoRoutes); 
		fprintf(stdout, "- Amount of time allowed for all pieces of a fragmented datagram to arrive : %d\n", pStats->dwReasmTimeout);
		fprintf(stdout, "- Number of datagrams requiring reassembly : %d\n", pStats->dwReasmReqds);
		fprintf(stdout, "- Number of datagrams successfully reassembled : %d\n", pStats->dwReasmOks);
		fprintf(stdout, "- Number of datagrams that cannot be reassembled : %d\n", pStats->dwReasmFails);
		fprintf(stdout, "- Number of datagrams that were fragmented successfully : %d\n", pStats->dwFragOks);
		fprintf(stdout, "- Number of datagrams that cannot be fragmented : %d\n", pStats->dwFragFails);
		fprintf(stdout, "- Number of fragments created : %d\n", pStats->dwFragCreates);
		fprintf(stdout, "- Number of interfaces : %d\n", pStats->dwNumIf);
		fprintf(stdout, "- Number of IP addresses associated with this computer : %d\n", pStats->dwNumAddr);
		fprintf(stdout, "- Number of routes in the IP routing table : %d\n", pStats->dwNumRoutes);
	}
	else
	{
		fprintf(stdout, "Error: %d\n", GetLastError());
		return(-1);
	}

	return(0);
}

char *DisplayInterfaceType(DWORD type)
{
	switch(type)
	{
		case MIB_IF_TYPE_ETHERNET:
			return("ETHERNET");
			break;
		case MIB_IF_TYPE_TOKENRING:
			return("TOKENRING");
			break;
		case MIB_IF_TYPE_FDDI:
			return("FDDI");
			break;
		case MIB_IF_TYPE_PPP:
			return("PPP");
			break;
		case MIB_IF_TYPE_LOOPBACK:
			return("LOOPBACK");
			break;
		case MIB_IF_TYPE_SLIP:
			return("SLIP");
			break;
		}
	return(NULL);
}

char *DisplayInterfaceStatus(DWORD status)
{
	switch(status)
	{
		case MIB_IF_OPER_STATUS_NON_OPERATIONAL:
			return("NON OPERATIONAL");
			break;
		case MIB_IF_OPER_STATUS_UNREACHABLE:
			return("UNREACHABLE");
			break;
		case MIB_IF_OPER_STATUS_DISCONNECTED:
			return("DISCONNECTED");
			break;
		case MIB_IF_OPER_STATUS_CONNECTING:
			return("CONNECTING");
			break;
		case MIB_IF_OPER_STATUS_CONNECTED:
			return("CONNECTED");
			break;
		case MIB_IF_OPER_STATUS_OPERATIONAL:
			return("OPERATIONAL");
			break;
		}
	return(NULL);
}


int GetAndDisplayInterfaceInfos(void)
{
	ULONG dwOutBufLen;
	PMIB_IFTABLE IfTable;
	PIP_INTERFACE_INFO InterfaceInfo;
	unsigned int i;
	char *buffer = NULL;

	dwOutBufLen = GetIfTable(NULL, &dwOutBufLen, TRUE);
	dwOutBufLen = (dwOutBufLen + 1) * sizeof(MIB_IFTABLE) ;
	IfTable = (PMIB_IFTABLE)malloc(dwOutBufLen * sizeof(IfTable));
    
	if(GetIfTable(IfTable, &dwOutBufLen, TRUE) == NO_ERROR)
	{
		fprintf(stdout, "===========================\n");
		fprintf(stdout, "= Interfaces Informations =\n");
		fprintf(stdout, "===========================\n\n");
 
		fprintf(stdout, "=> Numbers of Interfaces : %d", IfTable->dwNumEntries);

		for(i=0; i < IfTable->dwNumEntries; i++)
		{			
			fprintf(stdout, "\n\n- Interface %d -\n\n", i+1);
			fprintf(stdout, " => Index\t\t0x%8.8x\n", IfTable->table[i].dwIndex);
			
			IfTable->table[i].bDescr[IfTable->table[i].dwDescrLen]='\0';         
			fprintf(stdout," => Description\t\t%s\n",(int)IfTable->table[i].bDescr);

			/* Fucking bug with IfTable->table[i].wszName @#! */

			dwOutBufLen = GetInterfaceInfo(NULL, &dwOutBufLen);
			dwOutBufLen = (dwOutBufLen + 1) * sizeof(IP_INTERFACE_INFO);
			InterfaceInfo = (PIP_INTERFACE_INFO)malloc(dwOutBufLen * sizeof(InterfaceInfo));

			GetInterfaceInfo(InterfaceInfo, &dwOutBufLen);
			buffer = (char *)malloc(MAX_ADAPTER_NAME);
			wsprintf(buffer, "%S", InterfaceInfo->Adapter[i].Name);
			fprintf(stdout, " => Device Name\t\t%s\n", buffer);

			free(buffer);
			buffer = NULL;
			free(InterfaceInfo);
			
			fprintf(stdout," => Mac.Addr\t\t%2.2X-%2.2X-%2.2X-%2.2X-%2.2X-%2.2X\n"
                     	,(unsigned char)IfTable->table[i].bPhysAddr[0]
                     	,(unsigned char)IfTable->table[i].bPhysAddr[1]
                     	,(unsigned char)IfTable->table[i].bPhysAddr[2]
                     	,(unsigned char)IfTable->table[i].bPhysAddr[3]
                     	,(unsigned char)IfTable->table[i].bPhysAddr[4]
                     	,(unsigned char)IfTable->table[i].bPhysAddr[5]
					 );
			
			fprintf(stdout, " => Type\t\t%s\n", DisplayInterfaceType(IfTable->table[i].dwType));
			fprintf(stdout, " => Speed\t\t%d\n", IfTable->table[i].dwSpeed/1000/1000);
			fprintf(stdout, " => MTU\t\t\t%d\n", IfTable->table[i].dwMtu);
			fprintf(stdout, " => Octets recv\t\t%d Mo\n", IfTable->table[i].dwInOctets/1000/1000);
			fprintf(stdout, " => Octets sent\t\t%d Mo\n", IfTable->table[i].dwOutOctets/1000/1000);
			fprintf(stdout, " => Status\t\t%s\n", DisplayInterfaceStatus(IfTable->table[i].dwOperStatus));	
		} 
	}
	else
		fprintf(stdout, "Error: %d\n", GetLastError());

	free(IfTable);

	return(0);
}

int GetAndDisplayTcpStatistics(void)
{
	PMIB_TCPSTATS pStats;

	pStats = (PMIB_TCPSTATS)malloc(sizeof(PMIB_TCPSTATS));
	free(pStats);

	if(GetTcpStatistics(pStats) == NO_ERROR)
	{
		fprintf(stdout, "==================\n");
		fprintf(stdout, "= TCP Statistics =\n");
		fprintf(stdout, "==================\n\n");
		fprintf(stdout, "- Retransmission time-out algorithm in use : %d\n", pStats->dwRtoAlgorithm);
		fprintf(stdout, "- Minimum retransmission time-out value in milliseconds : %d\n", pStats->dwRtoMin);
		fprintf(stdout, "- Maximum retransmission time-out value in milliseconds : %d\n", pStats->dwRtoMax);
		fprintf(stdout, "- Maximum number of connections : %d\n", pStats->dwMaxConn);
		fprintf(stdout, "- Number of active opens : %d\n", pStats->dwActiveOpens);
		fprintf(stdout, "- Number of passive opens : %d\n", pStats->dwPassiveOpens);
		fprintf(stdout, "- Number of failed connection attempts : %d\n", pStats->dwAttemptFails);
		fprintf(stdout, "- Number of established connections that have been reset : %d\n", pStats->dwEstabResets);
		fprintf(stdout, "- Number of currently established connections : %d\n", pStats->dwCurrEstab);
		fprintf(stdout, "- Number of segments received or transmitted : %d\n", pStats->dwInSegs);
		fprintf(stdout, "- The number of segments transmitted : %d\n", pStats->dwOutSegs);
		fprintf(stdout, "- Number of segments retransmitted : %d\n", pStats->dwRetransSegs);
		fprintf(stdout, "- Number of errors received : %d\n", pStats->dwInErrs);
		fprintf(stdout, "- Number of segments transmitted with the reset flag set : %d\n", pStats->dwOutRsts);
		fprintf(stdout, "- Cumulative number of connections : %d\n", pStats->dwNumConns);
	}
	else
	{
		fprintf(stdout, "Error: %d\n", GetLastError());
		return(-1);
	}

	return(0);
}

int GetAndDisplayUdpStatistics(void)
{
	PMIB_UDPSTATS pStats;

	pStats = (PMIB_UDPSTATS)malloc(sizeof(PMIB_UDPSTATS));
	free(pStats);

	if(GetUdpStatistics(pStats) == NO_ERROR)
	{
		fprintf(stdout, "==================\n");
		fprintf(stdout, "= UDP Statistics =\n");
		fprintf(stdout, "==================\n\n");
		fprintf(stdout, "- Number of datagrams received : %d\n", pStats->dwInDatagrams);
		fprintf(stdout, "- Number of received datagrams that were discarded because the port specified was invalid : %d\n", pStats->dwNoPorts);
		fprintf(stdout, "- Number of erroneous datagrams that were received : %d\n", pStats->dwInErrors);
		fprintf(stdout, "- Number of datagrams transmitted : %d\n", pStats->dwOutDatagrams);
		fprintf(stdout, "- Number of entries in the UDP listener table : %d\n", pStats->dwNumAddrs);
	}
	else
	{
		fprintf(stdout, "Error: %d\n", GetLastError());
		return(-1);
	}

	return(0);
}

int GetAndDisplayIcmpStatistics(void)
{
	PMIB_ICMP pStats;

	pStats = (PMIB_ICMP)malloc(sizeof(PMIB_ICMP));
	free(pStats);
	
	if(GetIcmpStatistics(pStats) == NO_ERROR)
	{
		fprintf(stdout, "===================\n");
		fprintf(stdout, "= ICMP Statistics =\n");
		fprintf(stdout, "===================\n\n");
		fprintf(stdout, " - INCOMING ICMP MESSAGES -\n\n");
		fprintf(stdout, "- Number of messages received or sent : %d\n", pStats->stats.icmpInStats.dwMsgs);
		fprintf(stdout, "- Number of errors received or sent : %d\n", pStats->stats.icmpInStats.dwErrors);
		fprintf(stdout, "- Number of destination-unreachable messages received or sent : %d\n", pStats->stats.icmpInStats.dwDestUnreachs);
		fprintf(stdout, "- Number of time-to-live (TTL) exceeded messages received or sent : %d\n", pStats->stats.icmpInStats.dwTimeExcds);
		fprintf(stdout, "- Number of parameter problem messages received or sent : %d\n", pStats->stats.icmpInStats.dwParmProbs);
		fprintf(stdout, "- Number of source quench messages received or sent : %d\n", pStats->stats.icmpInStats.dwSrcQuenchs);
		fprintf(stdout, "- Number of redirect messages received or sent : %d\n", pStats->stats.icmpInStats.dwRedirects);
		fprintf(stdout, "- Number of echo requests received or sent : %d\n", pStats->stats.icmpInStats.dwEchos);
		fprintf(stdout, "- Number of echo replies received or sent : %d\n", pStats->stats.icmpInStats.dwEchoReps);
		fprintf(stdout, "- Number of time-stamp requests received or sent : %d\n", pStats->stats.icmpInStats.dwTimestamps);
		fprintf(stdout, "- Number of time-stamp replies received or sent : %d\n", pStats->stats.icmpInStats.dwTimestampReps);
		fprintf(stdout, "- Number of address mask requests received or sent : %d\n", pStats->stats.icmpInStats.dwAddrMasks);
		fprintf(stdout, "- Number of address mask responses received or sent : %d\n", pStats->stats.icmpInStats.dwAddrMaskReps);


		fprintf(stdout, "\n - OUTGOING ICMP MESSAGES -\n\n");
		fprintf(stdout, "- Number of messages received or sent : %d\n", pStats->stats.icmpOutStats.dwMsgs);
		fprintf(stdout, "- Number of errors received or sent : %d\n", pStats->stats.icmpOutStats.dwErrors);
		fprintf(stdout, "- Number of destination-unreachable messages received or sent : %d\n", pStats->stats.icmpOutStats.dwDestUnreachs);
		fprintf(stdout, "- Number of time-to-live (TTL) exceeded messages received or sent : %d\n", pStats->stats.icmpOutStats.dwTimeExcds);
		fprintf(stdout, "- Number of parameter problem messages received or sent : %d\n", pStats->stats.icmpOutStats.dwParmProbs);
		fprintf(stdout, "- Number of source quench messages received or sent : %d\n", pStats->stats.icmpOutStats.dwSrcQuenchs);
		fprintf(stdout, "- Number of redirect messages received or sent : %d\n", pStats->stats.icmpOutStats.dwRedirects);
		fprintf(stdout, "- Number of echo requests received or sent : %d\n", pStats->stats.icmpOutStats.dwEchos);
		fprintf(stdout, "- Number of echo replies received or sent : %d\n", pStats->stats.icmpOutStats.dwEchoReps);
		fprintf(stdout, "- Number of time-stamp requests received or sent : %d\n", pStats->stats.icmpOutStats.dwTimestamps);
		fprintf(stdout, "- Number of time-stamp replies received or sent : %d\n", pStats->stats.icmpOutStats.dwTimestampReps);
		fprintf(stdout, "- Number of address mask requests received or sent : %d\n", pStats->stats.icmpOutStats.dwAddrMasks);
		fprintf(stdout, "- Number of address mask responses received or sent : %d\n", pStats->stats.icmpOutStats.dwAddrMaskReps);
	}
	else
	{
		fprintf(stdout, "Error: %d\n", GetLastError());
		return(-1);
	}

	return(0);
}